(function ($, window, document) {
    $.fn.extend({
        addCombinedModal: function (appData, callback) {
            $(document).ready(function () {
                var appEnv = '';
                var combinedToken;
                var appInfo;
                var userCookies;
                var userPii;
                var userTerms;
                var userMarketing;
                var cookiesData;
                var pInfoData;
                var windowWidth = $(window).width();

                var combinedStyles = "";
                combinedStyles += ".btn.disabled { cursor: not-allowed }";
                combinedStyles += ".mobileImage { width: 130px; }";
                combinedStyles += ".gdpr-acc-anchor {color: black; font-weight: bold; font-size: 15px }";
                combinedStyles += ".consentCheckbox { display: inline !important; transform: scale(1.2) }";
                combinedStyles += ".policyText { font-weight: bold } ";
                combinedStyles += ".consentAnchor {color: #ff9933; cursor: pointer; font-size: 15px; }";
                combinedStyles += ".consentTable { height: 250px; overflow: auto; }";
                combinedStyles += ".switch { position: relative; display: inline-block; width: 60px; height: 34px; } ";
                combinedStyles += ".switch input { display: none }";
                combinedStyles += ".slider { position: absolute; cursor: pointer; top: 1px; left: 2px; right: 0; bottom: 0; border-radius: 16px; background-color: #fff; border: 1px solid #d9d9d9; -webkit-transition: all 0.3s; transition: all 0.3s;}";
                combinedStyles += ".slider::before { position: absolute; content: ''; display: 'block'; left: -2px; top: 1px; width: 30px; height: 30px; border-radius: 16px; background-color: #fff; border: 1px solid #d9d9d9; -webkit-transition: all 0.3s; transition: all 0.3s;}";
                combinedStyles += "input[type=checkbox]:checked + .slider { background-color: #55D069 }";
                combinedStyles += "input:focus + .slider { box-shadow: 0 0 1px #2196F3 }";
                combinedStyles += "input[type=checkbox]:checked + .slider:before { -webkit-transform: translateX(26px); -ms-transform: translateX(26px); transform: translateX(26px); }";
                combinedStyles += ".slider.round { border-radius: 34px }";
                combinedStyles += ".slider.round::before { box-shadow: 0 0 5px rgba(0,0,0,0.3); border-radius: 50%; }";
                combinedStyles += ".slider.round.disabledColor { background-color: #acadae !important; cursor: not-allowed }";
                combinedStyles += ".combinedModalTitle {    font-size: 22px; text-align: right; margin-top: 30px; float: right;}";
                combinedStyles += ".border-right { border-right: 1px solid; }";
                combinedStyles += ".offspan {   padding-left: 32px; font-size: 13px; padding-top: 5px; color: #acadae;}";
                combinedStyles += ".bg-white { background-color: #ffffff; !important}";
                combinedStyles += ".onSpan {    padding-left: 5px; font-size: 13px; padding-top: 5px; color: white;}";
                combinedStyles += ".cookie-Name { color: #b4b4b4; font-weight: bold;}";
                combinedStyles += ".font-13 { font-size: 13px; font-weight: 500; }";
                combinedStyles += ".consentDescription { color: #acadae; }";
                combinedStyles += ".bg-disabled { background-color: #acadae; color: #FFFF; }";
                combinedStyles += ".btn-primary-color { color: #fff; background-color: #0066b3 !important; border-color: #0066b3 !important;}";
                combinedStyles += ".gdpr-arrow {border: solid black; border-width: 0 3px 3px 0; display: inline-block; padding: 3px; margin-top: 5px;}"
                combinedStyles += ".gdpr-acc-anchor:hover {color: black}";
                combinedStyles += "a:hover {color: #ff9933; }";
                combinedStyles += ".gdpr-arrow.down { transform: rotate(45deg); -webkit-transform: rotate(45deg);}";
                combinedStyles += ".gdpr-arrow.up {transform: rotate(-135deg); -webkit-transform: rotate(-135deg);}";
                combinedStyles = "<style>" + combinedStyles + "</style>";

                switch (appData.environment) {
                    case 'dev':
                        appEnv = 'https://privacyapi-dev.freeman.com/api';
                        break;
                    case 'test':
                        appEnv = 'https://privacyapi-test.freeman.com/api';
                        break;
                    case 'uat':
                        appEnv = 'https://privacyapi-uat.freeman.com/api';
                        break;
                    case 'prod':
                        appEnv = 'https://privacyapi.freeman.com/api';
                        break;
                }

                function onContinueClick(cookiedata, piidata, appinfo) {
                    if (!($('#continueButton').hasClass("disabled"))) {
                        // Save Cookie Consent
                        var cookieCellData = [];
                        var finalCookieData = [];
                        var MarketingCheckboxValue = $('#promotionsChkbox').is(":checked");
                        var cookieRowData = $('#gdpr-cookieModalBody').find('tr').map(function () {
                            return $(this);
                        }).get();

                        for (var i = 0; i < cookieRowData.length; i++) {
                            var eachCookieCellData = cookieRowData[i].find('td').map(function () {
                                return $(this).text();
                            }).get();
                            cookieCellData.push(eachCookieCellData);

                            cookieCellData[i][4] = $('#cookieCheckbox-' + (i)).is(":checked");

                            var cookieSource = cookieCellData[i];
                            var cookieObj = cookieSource.reduce(function (o, val, i) {
                                o[i] = val;
                                return o;
                            }, {});
                            if (cookieObj.hasOwnProperty(0)) {
                                cookieObj["CookieName"] = cookiedata[i][0]['Name'];
                                delete cookieObj[0];
                            }
                            if (cookieObj.hasOwnProperty(1)) {
                                delete cookieObj[1];
                            }
                            if (cookieObj.hasOwnProperty(2)) {
                                delete cookieObj[2];
                            }
                            if (cookieObj.hasOwnProperty(3)) {
                                delete cookieObj[3];
                            }
                            if (cookieObj.hasOwnProperty(4)) {
                                cookieObj["IsConsent"] = cookieObj[4];
                                delete cookieObj[4];
                            }
                            cookieObj["CookieConsentId"] = i;
                            finalCookieData.push(cookieObj);
                        }

                        var cookieConsentObject = {
                            "Username": appData['userName'],
                            "Application": appData['appName'],
                            "UserCookies": finalCookieData
                        };

                        // save Privacy Consent
                        var privacyCellData = [];
                        var finalPrivacyCellData = [];
                        var privacyRowData = $('#gdpr-privacyModalBody').find('tr').map(function () {
                            return $(this);
                        }).get();

                        for (var j = 0; j < privacyRowData.length; j++) {
                            var eachPrivacyCellData = privacyRowData[j].find('td').map(function () {
                                return $(this).text();
                            }).get();
                            privacyCellData.push(eachPrivacyCellData);

                            privacyCellData[j][3] = $('#privacyCheckbox-' + (j)).is(":checked");

                            var privacySource = privacyCellData[j];
                            var privacyObj = privacySource.reduce(function (o, val, j) {
                                o[j] = val;
                                return o;
                            }, {});
                            if (privacyObj.hasOwnProperty(0)) {
                                privacyObj["PIIField"] = piidata[j]['FieldName'];
                                delete privacyObj[0];
                            }
                            if (privacyObj.hasOwnProperty(1)) {
                                delete privacyObj[1];
                            }
                            if (privacyObj.hasOwnProperty(2)) {
                                delete privacyObj[2];
                            }
                            if (privacyObj.hasOwnProperty(3)) {
                                privacyObj["PIIConsentState"] = privacyObj[3] ? "Confirmed" : "Denied";
                                delete privacyObj[3];
                            }
                            privacyObj['PIIConsentId'] = j;
                            finalPrivacyCellData.push(privacyObj);
                        }

                        var privacyConsentObject = {
                            "Username": appData['userName'],
                            "Application": appData['appName'],
                            "UserPIIFields": finalPrivacyCellData
                        };

                        var userTermsConsent = {
                            "Username": appData['userName'],
                            "Application": appData['appName'],
                            "IsConsent": true
                        };

                        var marketingConsent = {
                            "Username": appData['userName'],
                            "Application": appData['appName'],
                            "IsConsent": MarketingCheckboxValue
                        };

                        // Send Cookie Consent
                        $.post(appEnv + "/cookieconsent/save", cookieConsentObject, function (data, status, xhr) {
                            // Send Privacy Consent
                            $.post(appEnv + "/piiconsent/save", privacyConsentObject, function (data, status, xhr) {
                                // Save User terms consent
                                $.post(appEnv + "/termsofuse/save", userTermsConsent, function (data, status, xhr) {
                                    // Save Marketing consent
                                    if (appinfo.IsMarketingData == true) {
                                        $.post(appEnv + "/marketing/save", marketingConsent, function (data, status, xhr) {

                                        });
                                    }
                                    $('#combinedModal').modal('hide');
                                });
                            });
                        });

                        var returnConsent = {
                            "Username": appData['userName'],
                            "Application": appData['appName'],
                            "UserCookies": finalCookieData,
                            "UserPIIFields": finalPrivacyCellData,
                            "Token": combinedToken,
                            "UserTermsConsent": true,
                            "UserMarketingConsent": appinfo.IsMarketingData == true ? MarketingCheckboxValue : false
                        };

                        callback(returnConsent);
                    }
                }

                $(this).getToken(appData, appEnv, function (returnToken) {
                    combinedToken = returnToken;
                    // Set up request header with ApiKey for Security
                    $.ajaxSetup({
                        headers: {
                            'X-ApiKey': appData.apiKey,
                            'X-Authorization-Token': combinedToken
                        }
                    });

                    var getUserCookies = appEnv + "/cookieconsent/APP_NAME/USER_NAME/EMAIL"
                        .replace(/APP_NAME/g, appData['appName'])
                        .replace(/USER_NAME/g, appData['userName'])
                        .replace(/EMAIL/g, appData['email']);

                    var getUserPii = appEnv + "/piiconsent/APP_NAME/USER_NAME/EMAIL"
                        .replace(/APP_NAME/g, appData['appName'])
                        .replace(/USER_NAME/g, appData['userName'])
                        .replace(/EMAIL/, appData['email']);

                    var getAppInfo = appEnv + "/application/APP_NAME"
                        .replace(/APP_NAME/g, appData['appName']);

                    var getUserTerms = appEnv + "/termsofuse/APP_NAME/USER_NAME/EMAIL"
                        .replace(/APP_NAME/g, appData['appName'])
                        .replace(/USER_NAME/g, appData['userName'])
                        .replace(/EMAIL/, appData['email']);

                    var getMarketingData = appEnv + "/marketing/APP_NAME/USER_NAME"
                        .replace(/APP_NAME/g, appData['appName'])
                        .replace(/USER_NAME/g, appData['userName']);

                    $.get(getAppInfo, function (appResponse) {
                        appInfo = appResponse;
                        $.get(getUserCookies, function (cookieResponse) {
                            userCookies = cookieResponse;
                            $.get(getUserPii, function (piiResponse) {
                                userPii = piiResponse;
                                $.get(getUserTerms, function (termsResponse) {
                                    userTerms = termsResponse;
                                    if (appInfo['IsMarketingData'] == true) {
                                        $.get(getMarketingData, function (marketingResponse) {
                                            userMarketing = marketingResponse;
                                        });
                                    }

                                    if (userCookies['IsShow'] == true || userPii['IsShow'] == true || userTerms['IsShow'] == true) {
                                        var combinedModal = document.createElement('div');
                                        combinedModal.className = "modal fade";
                                        combinedModal.id = "combinedModal";
                                        combinedModal.tabIndex = "-1";
                                        combinedModal.setAttribute("role", "dialog");
                                        combinedModal.setAttribute("aria-labelledby", "combinedModal");
                                        combinedModal.setAttribute("aria-hidden", "true");
                                        combinedModal.setAttribute("data-backdrop", "static");
                                        combinedModal.setAttribute("data-keyboard", false);

                                        var modalDialog = document.createElement('div');
                                        modalDialog.className = "modal-dialog modal-lg";
                                        modalDialog.setAttribute("role", "document");

                                        var modalContent = document.createElement('div');
                                        modalContent.className = "modal-content";

                                        var modalHeader = document.createElement('div');
                                        modalHeader.className = "modal-header";

                                        var header = document.createElement("div");
                                        header.className = "modal-title policyText col-md-10 col-sm-8 combinedModalTitle";
                                        header.id = "gdpr-modalTitle";
                                        header.innerHTML = "Privacy Settings";

                                        var modalImage = document.createElement("img");
                                        if (appInfo['BrandingImageType'] != null && appInfo['BrandingImageBLOB'] != '') {
                                            modalImage.className = "col-md-2 border-right mobileImage";
                                            modalImage.setAttribute('src', appInfo['BrandingImageType'] + "," + appInfo['BrandingImageBLOB']);
                                        }

                                        modalHeader.appendChild(modalImage);
                                        modalHeader.appendChild(header);

                                        var modalBody = document.createElement('div');
                                        modalBody.className = "modal-body";

                                        var legalText = document.createElement("div");
                                        legalText.id = "gdpr-legalText";


                                        var committedMessage = document.createElement("h6");
                                        committedMessage.id = "gdpr-committedMessage";
                                        committedMessage.className = "policyText consentDescription";
                                        committedMessage.innerHTML = "Freeman is committed to protecting the privacy of our clients so we would like to be transparent about the cookies and personal information we collect and how we utilize it. Please review our policies provided in the links below and provide your consent where required so we can ensure we are continuing to provide the best customer experience possible.";

                                        var noteMessage = document.createElement("h6");
                                        noteMessage.id = "gdpr-noteMessage";
                                        noteMessage.className = "policyText consentDescription";
                                        noteMessage.innerHTML = "Please note we may still be required to correspond with you regarding transactions, services, or products we are providing to you or the organization you are part of.";

                                        legalText.appendChild(committedMessage);
                                        legalText.appendChild(noteMessage);


                                        // Create Accordions
                                        var accordionGroup = document.createElement("div");

                                        var accordionFragments = document.createDocumentFragment();
                                        var accordion = document.createElement("div");
                                        accordion.id = "gdpr-accordion";
                                        accordion.style.width = "100%";

                                        var accordions = ['Cookie Consent', 'Personal Information Consent']
                                        accordions.forEach(function (acc) {
                                            var accCard = document.createElement("div");
                                            accCard.className = "card";
                                            accCard.style.marginBottom = '10px';
                                            accCard.id = "gdpr-accCard-" + acc.replace(/\s+/g, '');

                                            var accCardHeader = document.createElement('div');
                                            accCardHeader.className = 'card-header';
                                            accCardHeader.style.cursor = "pointer";
                                            accCardHeader.id = "gdpr-panel-" + acc.replace(/\s+/g, "");
                                            accCardHeader.setAttribute('data-toggle', 'collapse');
                                            accCardHeader.setAttribute('data-target', '#gdpr-accCollapse-' + acc.replace(/\s+/g, ""));

                                            var anchorAcc = document.createElement("a");
                                            anchorAcc.id = "gdpr-anchor-" + acc.replace(/\s+/g, "");
                                            anchorAcc.className = "card-link gdpr-acc-anchor";
                                            anchorAcc.innerHTML = acc;
                                            anchorAcc.setAttribute('href', '#');


                                            // TODO: ARROW ICON - Use EffectiveUI's icon or image
                                            var arrowDown = document.createElement("i");
                                            arrowDown.id = "gdpr-arrowDown-" + acc.replace(/\s+/g, "");
                                            arrowDown.style.cssFloat = "right";
                                            arrowDown.className = "gdpr-arrow down";

                                            anchorAcc.appendChild(arrowDown);

                                            accCardHeader.appendChild(anchorAcc);

                                            var accCollapse = document.createElement("div");
                                            accCollapse.id = "gdpr-accCollapse-" + acc.replace(/\s+/g, "");
                                            accCollapse.className = "collapse";
                                            accCollapse.setAttribute('data-parent', '#gdpr-accordion');

                                            var accCardBody = document.createElement("div");
                                            accCardBody.id = "gdpr-accordion-" + acc.replace(/\s+/g, "");
                                            accCardBody.className = "card-body";
                                            accCardBody.style.overflow = "auto";
                                            accCollapse.appendChild(accCardBody);

                                            accCard.appendChild(accCardHeader);
                                            accCard.appendChild(accCollapse);
                                            accordion.appendChild(accCard);
                                            accordionFragments.appendChild(accordion);
                                            accordionGroup.appendChild(accordionFragments);

                                            accCardHeader.addEventListener('click', function (element) {
                                                if (element['currentTarget']['id'] == 'gdpr-panel-CookieConsent') {
                                                    if ($('#gdpr-accCollapse-CookieConsent').hasClass('show')) {
                                                        $('#gdpr-arrowDown-CookieConsent').removeClass('up');
                                                        $('#gdpr-arrowDown-CookieConsent').addClass('down');
                                                    } else {
                                                        $('#gdpr-arrowDown-CookieConsent').removeClass('down');
                                                        $('#gdpr-arrowDown-CookieConsent').addClass('up');
                                                    }

                                                    if ($('#gdpr-accCollapse-PersonalInformationConsent').hasClass('show')) {
                                                        $('#gdpr-arrowDown-PersonalInformationConsent').removeClass('up');
                                                        $('#gdpr-arrowDown-PersonalInformationConsent').addClass('down');
                                                    }
                                                }

                                                if (element['currentTarget']['id'] == 'gdpr-panel-PersonalInformationConsent') {
                                                    if ($('#gdpr-accCollapse-PersonalInformationConsent').hasClass('show')) {
                                                        $('#gdpr-arrowDown-PersonalInformationConsent').removeClass('up');
                                                        $('#gdpr-arrowDown-PersonalInformationConsent').addClass('down');
                                                    } else {
                                                        $('#gdpr-arrowDown-PersonalInformationConsent').removeClass('down');
                                                        $('#gdpr-arrowDown-PersonalInformationConsent').addClass('up');
                                                    }

                                                    if ($('#gdpr-accCollapse-CookieConsent').hasClass('show')) {
                                                        $('#gdpr-arrowDown-CookieConsent').removeClass('up');
                                                        $('#gdpr-arrowDown-CookieConsent').addClass('down');
                                                    }
                                                }

                                            });

                                            if (acc == 'Cookie Consent') {
                                                var cookieContainer = document.createElement("div");
                                                cookieContainer.className = "container";
                                                cookieContainer.id = "gdpr-cookieContainer";

                                                var cookieRow = document.createElement("div");
                                                cookieRow.className = "row";
                                                cookieRow.id = "gdpr-cookieRow";

                                                if (windowWidth >= 1024) {
                                                    var cookieRowHeader = document.createElement("h6");
                                                    cookieRowHeader.className = "policyText consentDescription";
                                                    cookieRowHeader.id = "gdpr-cookieRowHeader";
                                                    cookieRowHeader.innerHTML = "Our website uses cookies and other technologies so that we can remember you and understand how you and other visitors use our site.\n" +
                                                        "We want you to have control over the information we collect, please confirm your cookie preferences and review our \n";

                                                    var CPolicy = document.createElement('a');
                                                    CPolicy.id = "aSpan";
                                                    CPolicy.setAttribute("href", appInfo['CookiePolicyURL']);
                                                    CPolicy.setAttribute("target", "_blank");
                                                    CPolicy.innerHTML = "Cookie Policy.";
                                                    CPolicy.className = "consentAnchor";

                                                    cookieRowHeader.appendChild(CPolicy);

                                                    cookieRow.appendChild(cookieRowHeader);
                                                } else {
                                                    var cookieRowHeader = document.createElement('h6');
                                                    cookieRowHeader.className = "policyText consentDescription";
                                                    cookieRowHeader.style.display = 'inline';
                                                    cookieRowHeader.id = "gdpr-cookieRowHeader";
                                                    cookieRowHeader.innerHTML = "Our website uses cookies and other technologies so that we can remember you and understand how you and other visitors use our site. ";

                                                    var cookieAnchorMore = document.createElement('a');
                                                    cookieAnchorMore.id = 'gdpr-cookieAnchorMore';
                                                    cookieAnchorMore.innerHTML = '...more';
                                                    cookieAnchorMore.setAttribute('href', "#");
                                                    cookieAnchorMore.addEventListener('click', function (element) {
                                                        document.getElementById('gdpr-cookieSpanText').style.display = 'inline';
                                                        document.getElementById('gdpr-cookieAnchorMore').style.display = 'none';
                                                    });

                                                    cookieRowHeader.appendChild(cookieAnchorMore);
                                                    var cookieSpanText = document.createElement('span');
                                                    cookieSpanText.id = 'gdpr-cookieSpanText';
                                                    cookieSpanText.style.display = 'none';

                                                    var cookieMoreText = document.createElement('h6');
                                                    cookieMoreText.id = 'gdpr-cookieMoreText';
                                                    cookieMoreText.className = 'policyText consentDescription';
                                                    cookieMoreText.innerHTML = "For more information see our\n";

                                                    var cookiePolicy = document.createElement('a');
                                                    cookiePolicy.className = "consentAnchor";
                                                    cookiePolicy.setAttribute("href", appInfo['CookiePolicyURL']);
                                                    cookiePolicy.setAttribute("target", "_blank");
                                                    cookiePolicy.innerHTML = "Cookie Policy.";

                                                    cookieMoreText.appendChild(cookiePolicy);

                                                    var pCookieTag = document.createElement('h6');
                                                    pCookieTag.innerHTML = "We want you to control the information we collect, so please indicate your approval for us to collect the below information:";
                                                    pCookieTag.className = 'policyText consentDescription';
                                                    cookieRow.appendChild(pCookieTag);

                                                    var cookieAnchorLess = document.createElement('a');
                                                    cookieAnchorLess.id = 'cookieAnchorLess';
                                                    cookieAnchorLess.innerHTML = '...less';
                                                    cookieAnchorLess.style.display = "inline";
                                                    cookieAnchorLess.style.fontWeight = "bold";
                                                    cookieAnchorLess.setAttribute('href', "#");
                                                    cookieAnchorLess.addEventListener('click', function (element) {
                                                        document.getElementById('gdpr-cookieSpanText').style.display = 'none';
                                                        document.getElementById('gdpr-cookieAnchorMore').style.display = 'inline';
                                                    });

                                                    cookieSpanText.appendChild(cookieMoreText);
                                                    cookieSpanText.appendChild(pCookieTag);

                                                    cookieSpanText.appendChild(cookieAnchorLess);
                                                    cookieRow.appendChild(cookieRowHeader);
                                                    cookieRow.appendChild(cookieSpanText);
                                                }

                                                var cookieChangeDiv = document.createElement('div');
                                                cookieChangeDiv.id = "gdpr-cookieChange";
                                                cookieChangeDiv.className = "row";

                                                var cookieBothChange = document.createElement('p');
                                                cookieBothChange.id = 'cookieBothChange';
                                                cookieBothChange.className = 'consentDescription';
                                                cookieBothChange.innerHTML = "Our policy has been updated. See yellow highlights for changes.";
                                                $(cookieBothChange).css({
                                                    fontWeight: 'bold',
                                                    display: 'none',
                                                    fontStyle: 'italic',
                                                    backgroundColor: '#fcfb41'
                                                });
                                                cookieChangeDiv.appendChild(cookieBothChange);

                                                if (appInfo['IsReconsent'] == true) {
                                                    var cookieChange = document.createElement('p');
                                                    cookieChange.id = 'cookieChange';
                                                    cookieChange.className = 'consentDescription';
                                                    cookieChange.appendChild(document.createElement('br'));
                                                    cookieChange.innerHTML = "Our policy has been updated. Please review and re-consent.";
                                                    $(cookieChange).css({
                                                        fontWeight: 'bold',
                                                        fontStyle: 'italic',
                                                        backgroundColor: '#fcfb41'
                                                    });
                                                    cookieChangeDiv.appendChild(cookieChange);
                                                }


                                                var cookieTabRow = document.createElement('div');
                                                cookieTabRow.className = "row consentTable";
                                                cookieTabRow.id = "gdpr-cookieTabDiv";

                                                var cookieTable = document.createElement('table');
                                                cookieTable.id = "gdpr-cookieTable";
                                                cookieTable.className = "table";

                                                var cookieHead = document.createElement('thead');

                                                var cookieTableRow = document.createElement('tr');

                                                var cookieCellFragment = document.createDocumentFragment();
                                                var cookieTableHeaders = windowWidth >= 1024 ? ['Cookie', 'Purpose', 'Consent'] : ['Cookie', 'Consent'];

                                                cookieTableHeaders.forEach(function (header) {
                                                    var cell = document.createElement('th');
                                                    cell.textContent = header;
                                                    cookieCellFragment.appendChild(cell);
                                                });

                                                var cookieModalBody = document.createElement('tbody');
                                                cookieModalBody.id = "gdpr-cookieModalBody";

                                                cookieTableRow.appendChild(cookieCellFragment);
                                                cookieHead.appendChild(cookieTableRow);
                                                cookieTable.appendChild(cookieHead);
                                                cookieTable.appendChild(cookieModalBody);
                                                cookieTabRow.appendChild(cookieTable);
                                                cookieContainer.appendChild(cookieRow);
                                                cookieContainer.appendChild(cookieChangeDiv);
                                                cookieContainer.appendChild(cookieTabRow);
                                                accCardBody.appendChild(cookieContainer);
                                            }

                                            if (acc == 'Personal Information Consent') {
                                                var privacyContainer = document.createElement("div");
                                                privacyContainer.id = "gdpr-privacyContainer";
                                                privacyContainer.className = "container";

                                                var privacyRow = document.createElement("div");
                                                privacyRow.id = "gdpr-privacyRow";
                                                privacyRow.className = "row";

                                                if (windowWidth >= 1024) {
                                                    var privacyRowHeader = document.createElement("h6");
                                                    privacyRowHeader.className = "policyText consentDescription";
                                                    privacyRowHeader.id = "gdpr-privacyRowHeader";
                                                    privacyRowHeader.innerHTML = "At various times Freeman or its agents may collect personally identifiable information.  Freeman will use your personally identifiable information to perform the services you have contracted from us, where necessary for our legitimate interests (that are not overridden by your fundamental rights), to comply with a legal or regulatory obligation and as further detailed in each Freeman application.  For more specifics on our data handling, please review our\n";

                                                    var PrivacyPolicy = document.createElement('a');
                                                    PrivacyPolicy.id = "aSpan";
                                                    PrivacyPolicy.setAttribute("href", appInfo['PrivacyPolicyURL']);
                                                    PrivacyPolicy.setAttribute("target", "_blank");
                                                    PrivacyPolicy.innerHTML = "Privacy Policy.";
                                                    PrivacyPolicy.className = "consentAnchor";

                                                    privacyRowHeader.appendChild(PrivacyPolicy);

                                                    privacyRow.appendChild(privacyRowHeader);
                                                } else {
                                                    var privacyRowHeader = document.createElement('h6');
                                                    privacyRowHeader.className = "policyText consentDescription";
                                                    privacyRowHeader.style.display = 'inline';
                                                    privacyRowHeader.id = "gdpr-privacyRowHeader";
                                                    privacyRowHeader.innerHTML = "At various times Freeman or its agents may collect personally identifiable information. ";

                                                    var privacySpanText = document.createElement('span');
                                                    privacySpanText.id = 'gdpr-privacySpanText';
                                                    privacySpanText.style.display = 'none';

                                                    var privacyAnchorMore = document.createElement('a');
                                                    privacyAnchorMore.id = 'gdpr-privacyAnchorMore';
                                                    privacyAnchorMore.innerHTML = '...more';
                                                    privacyAnchorMore.setAttribute('href', '#');
                                                    privacyAnchorMore.addEventListener('click', function (element) {
                                                        document.getElementById('gdpr-privacySpanText').style.display = 'inline';
                                                        document.getElementById('gdpr-privacyAnchorMore').style.display = 'none';
                                                    });
                                                    privacyRowHeader.appendChild(privacyAnchorMore);

                                                    var privacyMoreText = document.createElement('h6');
                                                    privacyMoreText.id = 'gdpr-privacyMoreText';
                                                    privacyMoreText.className = 'policyText consentDescription';
                                                    privacyMoreText.innerHTML = " Freeman will use your personally identifiable information to perform the services you have contracted from us, where necessary for our legitimate interests (that are not overridden by your fundamental rights), to comply with a legal or regulatory obligation and as further detailed in each Freeman application. For more specifics on our data handling, please see our\n";

                                                    var PrivacyPolicy = document.createElement('a');
                                                    PrivacyPolicy.id = "aSpan";
                                                    PrivacyPolicy.setAttribute("href", appInfo['PrivacyPolicyURL']);
                                                    PrivacyPolicy.setAttribute("target", "_blank");
                                                    PrivacyPolicy.innerHTML = "Privacy Policy.";
                                                    PrivacyPolicy.className = "consentAnchor";

                                                    privacyMoreText.appendChild(PrivacyPolicy);

                                                    var privacyAnchorLess = document.createElement('a');
                                                    privacyAnchorLess.id = 'privacyAnchorLess';
                                                    privacyAnchorLess.setAttribute('href', '#');
                                                    privacyAnchorLess.innerHTML = '...less';
                                                    privacyAnchorLess.style.display = "inline";
                                                    privacyAnchorLess.style.fontWeight = "bold";
                                                    privacyAnchorLess.setAttribute('href', "#");
                                                    privacyAnchorLess.addEventListener('click', function (element) {
                                                        document.getElementById('gdpr-privacySpanText').style.display = 'none';
                                                        document.getElementById('gdpr-privacyAnchorMore').style.display = 'inline';
                                                    });

                                                    privacySpanText.appendChild(privacyMoreText);
                                                    privacySpanText.appendChild(privacyAnchorLess);
                                                    privacyRow.appendChild(privacyRowHeader);
                                                    privacyRow.appendChild(privacySpanText);
                                                }

                                                var privacyChangeDiv = document.createElement('div');
                                                privacyChangeDiv.id = "gdpr-privacyChange";
                                                privacyChangeDiv.className = "row";
                                                var privacyBothChange = document.createElement('p');
                                                privacyBothChange.id = 'privacyBothChange';
                                                privacyBothChange.className = 'consentDescription';
                                                privacyBothChange.innerHTML = "Our policy has been updated. See yellow highlights for changes.";
                                                $(privacyBothChange).css({
                                                    fontWeight: 'bold',
                                                    display: 'none',
                                                    fontStyle: 'italic',
                                                    backgroundColor: '#fcfb41'
                                                });
                                                privacyChangeDiv.appendChild(privacyBothChange);
                                                if (appInfo['IsReconsent'] == true) {
                                                    var privacyChange = document.createElement('p');
                                                    privacyChange.id = 'privacyChange';
                                                    privacyChange.className = 'consentDescription';
                                                    privacyChange.innerHTML = "Our policy has been updated. Please review and re-consent.";
                                                    $(privacyChange).css({
                                                        fontWeight: 'bold',
                                                        fontStyle: 'italic',
                                                        backgroundColor: '#fcfb41'
                                                    });

                                                    privacyChangeDiv.appendChild(privacyChange);
                                                }

                                                var privacyTabRow = document.createElement('div');
                                                privacyTabRow.className = "row consentTable";
                                                privacyTabRow.id = "privacyTabRow";

                                                var privacyTable = document.createElement('table');
                                                privacyTable.id = "privacyTable";
                                                privacyTable.className = "table";

                                                var privacyHead = document.createElement('thead');

                                                var privacyTableRow = document.createElement('tr');

                                                var privacyCellFragment = document.createDocumentFragment();
                                                var privacyTableHeaders = windowWidth >= 1024 ? ['Name', 'How we use this data', 'Consent'] : ['Name', 'Consent'];

                                                privacyTableHeaders.forEach(function (header) {
                                                    var cell = document.createElement('th');
                                                    cell.textContent = header;
                                                    privacyCellFragment.appendChild(cell);
                                                });

                                                var privacyModalBody = document.createElement('tbody');
                                                privacyModalBody.id = "gdpr-privacyModalBody";

                                                privacyTableRow.appendChild(privacyCellFragment);
                                                privacyHead.appendChild(privacyTableRow);
                                                privacyTable.appendChild(privacyHead);
                                                privacyTable.appendChild(privacyModalBody);
                                                privacyTabRow.appendChild(privacyTable);
                                                privacyContainer.appendChild(privacyRow);
                                                privacyContainer.appendChild(privacyChangeDiv);
                                                privacyContainer.appendChild(privacyTabRow);
                                                accCardBody.appendChild(privacyContainer);
                                            }

                                        });

                                        // Complete Consent
                                        var completeConsentContainer = document.createElement("div");
                                        completeConsentContainer.id = "gdpr-completeConsentContainer";

                                        var termsHeader = document.createElement('h6');
                                        termsHeader.innerHTML = "Click ";
                                        termsHeader.className = "policyText";

                                        var TPolicy = document.createElement('a');
                                        TPolicy.id = "aSpan";
                                        TPolicy.setAttribute("href", appInfo['TermsConditionsURL']);
                                        TPolicy.setAttribute("target", "_blank");
                                        TPolicy.innerHTML = "here";
                                        TPolicy.className = "consentAnchor";

                                        var tSpan = document.createElement('span');
                                        tSpan.innerHTML = " to read our Terms of Use.";

                                        termsHeader.appendChild(TPolicy);
                                        termsHeader.appendChild(tSpan);

                                        var termslabel = document.createElement('label');
                                        var termstext = document.createElement('span');
                                        termstext.innerHTML = " I have read and agreed to Freeman's ";

                                        var termsPolicy = document.createElement('a');
                                        termsPolicy.id = "gdpr-TermsPolicy";
                                        termsPolicy.setAttribute("href", appInfo['TermsConditionsURL']);
                                        termsPolicy.setAttribute("target", "_blank");
                                        termsPolicy.innerHTML = "Terms of Use";
                                        termsPolicy.className = "consentAnchor";

                                        var CPolicy = document.createElement('a');
                                        CPolicy.id = "gdpr-CPolicy";
                                        CPolicy.setAttribute("href", appInfo['CookiePolicyURL']);
                                        CPolicy.setAttribute("target", "_blank");
                                        CPolicy.innerHTML = "Cookie Policy";
                                        CPolicy.className = "consentAnchor";

                                        var PPolicy = document.createElement('a');
                                        PPolicy.id = "gdpr-PPolicy";
                                        PPolicy.setAttribute("href", appInfo['PrivacyPolicyURL']);
                                        PPolicy.setAttribute("target", "_blank");
                                        PPolicy.innerHTML = "Privacy Policy";
                                        PPolicy.className = "consentAnchor";

                                        termstext.appendChild(CPolicy);
                                        termstext.appendChild(document.createTextNode(', '));
                                        termstext.appendChild(PPolicy);
                                        termstext.appendChild(document.createTextNode(' and '));
                                        termstext.appendChild(termsPolicy);
                                        termstext.appendChild(document.createTextNode(' and I have completed my consent selection for each section.'));

                                        // var termstext = document.createTextNode(' I have read and agreed to the Terms of Use, Privacy Policy and Cookie Policy.');
                                        var termsbox = document.createElement('input');
                                        termsbox.type = "checkbox";
                                        termsbox.id = "termsbox";
                                        termsbox.className = "consentCheckbox";
                                        termsbox.addEventListener('click', function (element) {
                                            if ($('#termsbox').is(":checked")) {
                                                $('#continueButton').removeClass("disabled bg-disabled").attr("rel", null);
                                                $('#continueButton').addClass("btn-primary btn-primary-color").attr("rel", null);
                                            } else if (!$('#termsbox').is(":checked")) {
                                                $('#continueButton').removeClass("btn-primary btn-primary-color").attr("rel", null);
                                                $('#continueButton').addClass("disabled bg-disabled").attr("rel", "tooltip");
                                            }
                                        });

                                        termslabel.appendChild(termsbox);
                                        termslabel.appendChild(termstext);
                                        // completeConsentContainer.appendChild(termsHeader);
                                        completeConsentContainer.appendChild(termslabel);

                                        modalBody.appendChild(legalText);
                                        modalBody.appendChild(document.createElement('br'));
                                        modalBody.appendChild(accordionGroup);
                                        modalBody.appendChild(document.createElement('br'));
                                        modalBody.appendChild(completeConsentContainer);


                                        var modalFooter = document.createElement('div');
                                        modalFooter.className = "modal-footer";

                                        var footerContainer = document.createElement('div');
                                        footerContainer.className = "container";

                                        var btnRow1 = document.createElement('div');
                                        btnRow1.className = "row";

                                        var column1 = document.createElement("div");
                                        column1.className = "col-8 col-md-10";
                                        column1.style.paddingLeft = "0";

                                        var marketingLabel = document.createElement('label');
                                        marketingLabel.id = "gdpr-marketingLabel";
                                        var marketingText = document.createTextNode(' Please keep me updated with Freeman news and promotions.');
                                        var marketingBox = document.createElement('input');
                                        marketingBox.type = "checkbox";
                                        marketingBox.id = "gdpr-marketingBox";
                                        marketingBox.className = "consentCheckbox";

                                        marketingLabel.appendChild(marketingBox);
                                        marketingLabel.appendChild(marketingText);
                                        marketingLabel.style.display = "none";
                                        column1.appendChild(marketingLabel);

                                        var column2 = document.createElement('div');
                                        column2.className = "col-4 col-md-2";
                                        column2.style.paddingRight = "0";
                                        column2.style.paddingLeft = "30px";

                                        var continueButton = document.createElement('button');
                                        continueButton.id = "continueButton";
                                        continueButton.type = "button";
                                        continueButton.innerHTML = "Continue";
                                        continueButton.className = "btn disabled bg-disabled";
                                        continueButton.setAttribute("data-title", "Please consent to the cookie policy, privacy poilcy and agree to Terms of use to continue");
                                        continueButton.addEventListener('click', function (element) {
                                            onContinueClick(cookiesData, pInfoData, appInfo);
                                        });

                                        column2.appendChild(continueButton);
                                        btnRow1.appendChild(column1);
                                        btnRow1.appendChild(column2);

                                        footerContainer.appendChild(btnRow1);
                                        modalFooter.appendChild(footerContainer);

                                        modalContent.appendChild(modalHeader);
                                        modalContent.appendChild(modalBody);
                                        modalContent.appendChild(modalFooter);
                                        modalDialog.appendChild(modalContent);
                                        combinedModal.appendChild(modalDialog);

                                        $(combinedStyles).appendTo('head');
                                        document.body.appendChild(combinedModal);
                                        $('#combinedModal').modal('show');

                                        var getAppCookies = appEnv + "/cookieconsent/APP_NAME"
                                            .replace(/APP_NAME/g, appData['appName']);

                                        var getPiiData = appEnv + "/piiconsent/APP_NAME"
                                            .replace(/APP_NAME/g, appData['appName']);

                                        $.get(getAppCookies, function (appCookies) {
                                            cookiesData = appCookies;
                                            $(this).addCookies(appData, appCookies, windowWidth);
                                        });

                                        $.get(getPiiData, function (appPii) {
                                            pInfoData = appPii;
                                            if (appInfo['IsMarketingData'] == true) {
                                                var UserPIIFieldsObj = appPii.filter(function (el) {
                                                    return el.FieldName == "Email";
                                                });
                                                if (UserPIIFieldsObj.length == 0) {
                                                    marketingLabel.style.display = "none";
                                                } else {
                                                    marketingLabel.style.display = UserPIIFieldsObj[0]['IsRequired'] ? "inline" : "none";
                                                }

                                            } else {
                                                marketingLabel.style.display = "none";
                                            }
                                            $(this).addPii(appData, appPii, windowWidth);
                                        });
                                    } else {
                                        userCookies.UserPIIFields = userPii['UserPIIFields'];
                                        userCookies.Token = combinedToken;
                                        callback(userCookies);
                                    }

                                });
                            });
                        });
                    });
                });
            });
        },
        addCookies: function (appData, cookiesData, windowWidth) {
            $('#gdpr-cookieModalBody').find('tr').remove();
            var cookiesBody = document.getElementById('gdpr-cookieModalBody');

            for (var i = 0; i < cookiesData.length; i++) {
                for (var j = 0; j < cookiesData[i].length; j++) {
                    var tr = document.createElement("TR");
                    tr.id = "tr-" + i + "" + j;

                    var rowFragment = document.createDocumentFragment();
                    var current = cookiesData[i][j];
                    var titles = windowWidth >= 1024 ? ['Name', 'Text', 'CookieConsentId'] : ['Name', 'CookieConsentId'];
                    titles.forEach(function (title) {
                        var td = document.createElement('td');
                        if (current['IsReconsent'] === true) {
                            $(td).css({
                                backgroundColor: '#fcfb41',
                                color: "#9a9997"
                            });

                            if (document.getElementById('cookieBothChange')) {
                                document.getElementById('cookieBothChange').style.display = 'inline-block';
                            }
                            if (document.getElementById('cookieChange')) {
                                document.getElementById('cookieChange').style.display = 'none';
                            }
                        } else {
                            $(td).css({
                                color: "#9a9997"
                            })
                        }
                        if (title === 'CookieConsentId') {
                            $(td).css({
                                width: "95px"
                            });
                            var switchCookieLabel = document.createElement("label");
                            switchCookieLabel.className = "switch";
                            var cookieCheckbox = document.createElement("input");
                            cookieCheckbox.type = "checkbox";
                            cookieCheckbox.checked = !current['IsActionable'];
                            cookieCheckbox.id = "cookieCheckbox-" + (i + j);
                            cookieCheckbox.disabled = cookieCheckbox.checked;
                            cookieCheckbox.className = cookieCheckbox.checked ? "disabled" : "";
                            var sliderCookieSpan = document.createElement('span');
                            if (cookieCheckbox.checked === true) {
                                sliderCookieSpan.innerText = "On";
                                sliderCookieSpan.className = "slider round disabledColor onSpan";
                            } else {
                                sliderCookieSpan.innerText = "Off";
                                sliderCookieSpan.className = "slider round bg-white offspan";
                            }
                            cookieCheckbox.onclick = function () {
                                if (cookieCheckbox.checked === true) {
                                    sliderCookieSpan.innerText = "On";
                                    sliderCookieSpan.className = "slider round onSpan";
                                } else {
                                    sliderCookieSpan.innerText = "Off";
                                    sliderCookieSpan.className = "bg-white slider round offspan";
                                }
                            };
                            switchCookieLabel.appendChild(cookieCheckbox);
                            switchCookieLabel.appendChild(sliderCookieSpan);
                            td.textContent = "";
                            td.appendChild(switchCookieLabel);
                        }
                        var IsRequiredCookie = document.createElement('p');
                        IsRequiredCookie.style.marginBottom = '0';
                        IsRequiredCookie.className = 'font-13';
                        var cookieCategory = document.createElement('p');
                        cookieCategory.style.marginBottom = '0';
                        cookieCategory.className = 'font-13';
                        if (title === 'Name') {
                            $(td).css({
                                width: "175px"
                            });
                            td.innerHTML = current[title];
                            td.className = "cookie-Name";
                            if (!current['IsActionable']) {
                                IsRequiredCookie.innerText = "(Required)";
                            } else {
                                IsRequiredCookie.innerText = "(Optional)";
                            }
                            cookieCategory.innerText = current['Category']['Category'];
                            td.appendChild(cookieCategory);
                            td.appendChild(IsRequiredCookie);
                        }
                        var categoryDesc = document.createElement('p');
                        if (title === 'Text') {

                            categoryDesc.innerHTML = current[title];
                            td.textContent = '';
                            td.appendChild(categoryDesc);
                        }
                        rowFragment.appendChild(td);
                    });
                    tr.appendChild(rowFragment);
                    cookiesBody.appendChild(tr);
                }
            }
        },
        addPii: function (appData, privacyData, windowWidth) {
            $('#gdpr-privacyModalBody').find('tr').remove();
            var privacyTBody = document.getElementById('gdpr-privacyModalBody');

            for (var i = 0; i < privacyData.length; i++) {
                var privacyTR = document.createElement('tr');
                privacyTR.id = 'tr-' + privacyData[i]['PIIConsentId'];

                var rowFragment = document.createDocumentFragment();
                var current = privacyData[i];
                var titles = windowWidth >= 1024 ? ['FieldName', 'Text', 'PIIConsentId'] : ['FieldName', 'PIIConsentId'];
                titles.forEach(function (title) {
                    var td = document.createElement('td');
                    var currentSpan = document.createElement('span');
                    currentSpan.id = 'currentSpan-' + privacyData[i]['PIIConsentId'];
                    currentSpan.innerHTML = title !== 'IsRequired' ? current[title] : (current[title] ? 'Required' : 'Optional');
                    td.appendChild(currentSpan);
                    if (current['IsReconsent'] === true) {
                        $(td).css({
                            backgroundColor: '#fcfb41',
                            color: "#9a9997"
                        });

                        if (document.getElementById('privacyBothChange')) {
                            document.getElementById('privacyBothChange').style.display = 'inline';
                        }
                        if (document.getElementById('privacyChange')) {
                            document.getElementById('privacyChange').style.display = 'none';
                        }
                    } else {
                        $(td).css({
                            color: "#9a9997"
                        })
                    }
                    if (title === 'Text') {
                        td.className = "more";
                    }
                    var IsRequiredPrivacy = document.createElement('p');
                    if (title === 'FieldName') {
                        $(td).css({
                            width: "150px"
                        });
                        td.innerHTML = current[title];
                        td.className = "cookie-Name";
                        IsRequiredPrivacy.className = "font-13";
                        if (!!privacyData[i]['IsRequired']) {
                            IsRequiredPrivacy.innerText = "(Required)";
                        } else {
                            IsRequiredPrivacy.innerText = "(Optional)";
                        }
                        td.appendChild(IsRequiredPrivacy);

                    }
                    if (title === 'PIIConsentId') {
                        $(td).css({
                            width: "95px"
                        });
                        var switchLabel = document.createElement("label");
                        switchLabel.className = "switch";
                        var checkbox = document.createElement("input");
                        checkbox.type = "checkbox";
                        checkbox.checked = !!privacyData[i]['IsRequired'];
                        checkbox.id = "privacyCheckbox-" + (i);
                        if (privacyData[i]['FieldName'] == "Email") {
                            emailID = checkbox.id;
                        }
                        checkbox.disabled = checkbox.checked;
                        checkbox.className = checkbox.checked ? "disabled" : "";
                        var sliderSpan = document.createElement('span');
                        if (checkbox.checked === true) {
                            sliderSpan.innerText = "On";
                            sliderSpan.className = "slider round disabledColor onSpan";
                        } else {
                            sliderSpan.innerText = "Off";
                            sliderSpan.className = "bg-white slider round offspan";
                        }
                        checkbox.onclick = function () {
                            if (checkbox.checked === true) {
                                sliderSpan.innerText = "On";
                                sliderSpan.className = "slider round onSpan";
                                if (privacyData[checkbox.id.split("-")[1]]['FieldName'] == 'Email') {
                                    var marketingCB = document.getElementById('gdpr-marketingLabel');
                                    marketingCB.style.display = "inline";
                                }
                            } else {
                                sliderSpan.innerText = "Off";
                                sliderSpan.className = "bg-white slider round offspan";
                                if (privacyData[checkbox.id.split("-")[1]]['FieldName'] == 'Email') {
                                    var marketingCB = document.getElementById('gdpr-marketingLabel');
                                    marketingCB.style.display = "none";
                                }
                            }
                        };
                        switchLabel.appendChild(checkbox);
                        switchLabel.appendChild(sliderSpan);

                        td.textContent = '';
                        td.appendChild(switchLabel);
                    }
                    rowFragment.appendChild(td);
                });
                privacyTR.appendChild(rowFragment);
                privacyTBody.appendChild(privacyTR);
            }
        },
        getToken: function (application, cEnv, callback) {
            var cTokenObject = {
                Application: application.appName,
                Username: application.userName,
                ApiKey: application.appKey
            };

            $.ajax({
                url: cEnv + "/utility/gettoken",
                type: 'POST',
                data: cTokenObject,
                headers: {
                    'X-ApiKey': application.apiKey
                },
                dataType: 'json',
                success: function (data) {
                    callback(data['Token']);
                }
            });
        }
    })
})(jQuery, window, document);